// pboxdlg.cpp
//      Implementation of the test dialog
//      Written by Christopher Dix, 2000

#include "stdafx.h"
#include "pboxtest.h"
#include "pboxdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////
// CPboxtestDlg dialog

CPboxtestDlg::CPboxtestDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CPboxtestDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CPboxtestDlg)
    //}}AFX_DATA_INIT
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pStatusList = NULL;
}

void CPboxtestDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CPboxtestDlg)
    DDX_Control(pDX, PROPBOX, m_PROPBOX);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPboxtestDlg, CDialog)
    //{{AFX_MSG_MAP(CPboxtestDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_WM_SIZE()
    ON_WM_DESTROY()
    //}}AFX_MSG_MAP
    ON_NOTIFY(PBN_PROPCHANGE, PROPBOX, OnNotifyPropChange)
    ON_NOTIFY(PBN_OWNERDROP, PROPBOX, OnNotifyOwnerDrop)
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////
// CPboxtestDlg message handlers

BOOL CPboxtestDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, 
                strAboutMenu);
	}
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);	    // Set big icon
    SetIcon(m_hIcon, FALSE);	    // Set small icon

    // Initialize the property box
    CPropertyItem* pItem = new CPropertyItem();
    CString strTemp;
    CRect rect;
    GetClientRect( rect );

    // Add a default property
    pItem->m_strProperty = "Window Caption";
    pItem->m_strValue = "Try to change this text...";
    m_PROPBOX.AddProperty( pItem );

    // Add a drop-down list property
    pItem = new CPropertyItem();
    pItem->m_strProperty = "Status";
    pItem->m_strValue = "Yellow";
    pItem->m_nFlags = PROP_DROPLIST | PROP_GETCHANGE;
    
    // Create the drop-down list box
    m_pStatusList = new CListBox();
    DWORD dwStyle = WS_CHILD | WS_BORDER | LBS_NOTIFY | 
        LBS_HASSTRINGS | LBS_WANTKEYBOARDINPUT;
    m_pStatusList->Create( dwStyle, CRect(0,0,1,1),
        &m_PROPBOX, 1001 ); 
    pItem->m_pLB = m_pStatusList;
    
    // Populate it
    pItem->m_pLB->AddString( "Red" );
    pItem->m_pLB->AddString( "Yellow" );
    pItem->m_pLB->AddString( "Green" );
    m_PROPBOX.AddProperty( pItem );

    // Create two read-only properties
    pItem = new CPropertyItem();
    pItem->m_strProperty = "Width";
    strTemp.Format( "%d", rect.Width() );
    pItem->m_strValue = strTemp;
    pItem->m_nFlags = PROP_READONLY;
    m_PROPBOX.AddProperty( pItem );

    pItem = new CPropertyItem();
    pItem->m_strProperty = "Height";
    strTemp.Format( "%d", rect.Height() );
    pItem->m_strValue = strTemp;
    pItem->m_nFlags = PROP_READONLY;    
    m_PROPBOX.AddProperty( pItem );

    // Create an owner-drop property
    pItem = new CPropertyItem();
    pItem->m_strProperty = "File Name";
    pItem->m_nFlags = PROP_OWNERDROP | PROP_EDIT;
    m_PROPBOX.AddProperty( pItem );

    m_PROPBOX.MoveWindow( rect ); 
    
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPboxtestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need 
// the code below to draw the icon.  For MFC applications 
// using the document/view model, this is automatically done 
// for you by the framework.

void CPboxtestDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, 
            (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while 
// the user drags the minimized window.
HCURSOR CPboxtestDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CPboxtestDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);

    if ( m_PROPBOX.GetSafeHwnd() )
    {
        // Size the property box to take up the entire window
        m_PROPBOX.MoveWindow( 0, 0, cx, cy);

        // Update the read-only Width and Height properties
        CString strTemp;
        strTemp.Format( "%d", cx );
        m_PROPBOX.SetValue( "Width", strTemp );
        strTemp.Format( "%d", cy );
        m_PROPBOX.SetValue( "Height", strTemp );
    }
}

// OnNotifyPropChange: 
//      Handles the PBN_PROPCHANGE message, fired whenever the 
//  value of a property is modified.
void CPboxtestDlg::OnNotifyPropChange( NMHDR * pNotifyStruct, 
    LRESULT * result )
{
    LPNMPBDISPINFO lpnmpb = (LPNMPBDISPINFO)pNotifyStruct;
    if ( lpnmpb )
    {
        // Handle the change if it is the "Window Caption"
        if ( lpnmpb->pItem->m_strProperty == "Window Caption" )
        {
            SetWindowText( lpnmpb->pItem->m_strValue );
            *result = 0;
            return;
        }
    }
    *result = 0;
}

// OnNotifyPropChange: 
//      Handles the PBN_OWNERDROP message, fired whenever the 
// drop-down button of a property that has the PROP_OWNERDROP 
// flag set has been clicked.
void CPboxtestDlg::OnNotifyOwnerDrop( NMHDR * pNotifyStruct, 
    LRESULT * result )
{
    // We only have one owner-drop property.  If we get
    // notified to handle it, display the common file
    // dialog.
    LPNMPBDISPINFO lpnmpb = (LPNMPBDISPINFO)pNotifyStruct;
    if ( lpnmpb )
    {
        CFileDialog dlg( true, NULL, lpnmpb->pItem->m_strValue, 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
        NULL, this );
        if ( dlg.DoModal() == IDOK )
        {
            m_PROPBOX.SetValue( lpnmpb->pItem->m_strProperty,
            dlg.GetPathName() );
        }
    }
    *result = 1;
}

void CPboxtestDlg::OnDestroy() 
{
    CDialog::OnDestroy();
	
    delete m_pStatusList;
}
