// perfm.h

#define PERFC_MEM       10
#define PERFC_DISK      20

#define PERFC_OK        0
#define PERFC_WARN      1
#define PERFC_ALERT     2

#define PERFC_LABEL     300
#define PERFC_ICON_BASE 100
#define PERFC_STR_BASE  200

#define ICON_MEM_OK     (PERFC_ICON_BASE+PERFC_MEM+PERFC_OK)
#define ICON_MEM_WARN   (PERFC_ICON_BASE+PERFC_MEM+PERFC_WARN)
#define ICON_MEM_ALERT  (PERFC_ICON_BASE+PERFC_MEM+PERFC_ALERT)

#define ICON_DISK_OK    (PERFC_ICON_BASE+PERFC_DISK+PERFC_OK)
#define ICON_DISK_WARN  (PERFC_ICON_BASE+PERFC_DISK+PERFC_WARN)
#define ICON_DISK_ALERT (PERFC_ICON_BASE+PERFC_DISK+PERFC_ALERT)

#define DEF_MEM_THRESH_OK       10
#define DEF_MEM_THRESH_WARN     10
#define DEF_MEM_THRESH_ALERT    10
#define DEF_MEM_FREQ            5000

#define DEF_DISK_THRESH_OK       10
#define DEF_DISK_THRESH_WARN     10
#define DEF_DISK_THRESH_ALERT    10
#define DEF_DISK_FREQ            5000

#define DLG_SETTINGS            1000
#define ID_LABEL                1001
#define ID_THR_WARN             1002
#define ID_THR_ALERT            1003
#define ID_THR_LESS             1004
#define ID_THR_MORE             1005
#define ID_FREQ                 1006

typedef struct _PERFC_DATA {
    DWORD  dwId;
    TCHAR  szObject[MAX_PATH];
    TCHAR  szInstance[MAX_PATH];
    TCHAR  szCounter[MAX_PATH];
    DWORD  dwFreq;
    DWORD  dwThrAlert;
    DWORD  dwThrWarn;
    BOOL   bThrLow;
    HANDLE hMonitorThread;
    HWND   hWnd;
} PERFC_DATA, *PPERFC_DATA;

